#!/bin/bash
###############################################################################
#
# Remove a vserver.
#
# Copyright (C) 2003 nuBridges llc
# Released under the Gnu General Public License, Version 2
# Copyright (C) 2003  nuBridges llc
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# $Id: rmVS.sh,v 1.5 2003/11/13 21:05:27 cshapiro Exp $
#
#############################################################################

#
# Usage message.
#
usage () 
{
	echo Usage: $1 vservername

	cat <<EOU

	Destroy, unlink, remove, and expunge virtual server vservername.
	Beware! Make sure that you want to do this, because it is 
	NOT REVERSIBLE.
EOU
}
# 
# Make sure we want to remove this vserver.
#
askSure() {
	unset YN
	while [ -z $YN ]
	do
		echo $1
		read YN
		if echo $YN | grep "^[^YyNn]" > /dev/null
		then
			YN=""
		fi
		if [ ! -z $YN ]
		then
			if echo $YN | grep "^[Yy]" > /dev/null
			then
				RVAL=0
			else	
				RVAL=1
			fi
		fi
	done
		return $RVAL
}

#
# Main Line
#
VSDIR=/vservers
VSPARMDIR=/etc/vservers
PARMSDIR=${HOME}/vbuild.params

if [ -z $1 ]
then
	usage $0
	exit 1
fi

if [ ! -d $VSDIR/$1 ]
then
	echo $1 does not appear to be a vserver.
	usage $0
	exit 1
fi
if /usr/sbin/vserver $1 running > /dev/null
then
	echo Oops. This vserver is still running. Please stop it
	echo before attempting to remove it.
	exit 1
fi

if /sbin/ifconfig -a | grep $1 > /dev/null
then
	echo Oog. This vserver still has an ethernet device enabled. 
        echo Please try again later when this device has gone away.
        exit 1
fi

if askSure  "Really expunge vserver $1 (y/n)?"
then
	echo Removing vserver $1...
	rm -rf $VSDIR/$1
	rm $VSPARMDIR/$1.conf
        nextIP.pl -f $PARMSDIR/current.ip.num  -o r -n $1.nubridges.net
	echo Expunged!
else
	echo Nothing done.
fi
